import React, { useEffect, useState } from 'react';
export default (function (props) {
  var _useState = useState(false),
      dragOver = _useState[0],
      setDragOver = _useState[1];

  var _onDragOver = function onDragOver(e) {
    e.preventDefault();
    setDragOver(true);
  };

  var _onDragLeave = function onDragLeave(e) {
    setDragOver(false);
  };

  var dropCallback = function dropCallback() {
    setDragOver(false);
  };

  if (props.onDragExisitingField) {
    return /*#__PURE__*/React.createElement("div", {
      onDragOver: function onDragOver(e) {
        _onDragOver(e);
      },
      onDrop: function onDrop(e) {
        props.onDrop(props.data.index, props.data.field.type, props.data.field.uuid, props.data.field.order, e, dropCallback);
      },
      onDragLeave: function onDragLeave(e) {
        _onDragLeave(e);
      }
    }, /*#__PURE__*/React.createElement("div", {
      className: dragOver ? " droppable-border-active " : '',
      style: {
        height: dragOver ? 70 : 10
      }
    }));
  }

  return /*#__PURE__*/React.createElement("div", {
    onDragOver: function onDragOver(e) {
      _onDragOver(e);
    },
    onDrop: function onDrop(e) {
      props.onDrop(e, props.order, dropCallback);
    },
    onDragLeave: function onDragLeave(e) {
      _onDragLeave(e);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: dragOver ? " droppable-border-active " : '',
    style: {
      height: dragOver ? 70 : 10
    }
  }));
});