import React from 'react';
import { Tooltip } from '@material-ui/core';
export default function ImageWrapper(props) {
  var renderTooltip = function renderTooltip() {
    if (props.data.config.tooltip && props.data.config.tooltip !== '') {
      return /*#__PURE__*/React.createElement(Tooltip, {
        title: props.data.config.tooltip
      }, renderLink());
    } else {
      return renderLink();
    }
  };

  var renderLink = function renderLink() {
    if (props.data.config.href) {
      return /*#__PURE__*/React.createElement("a", {
        href: props.data.config.href,
        target: "_blank",
        rel: "noopener noreferrer"
      }, /*#__PURE__*/React.createElement("img", {
        src: props.data.config.url,
        className: "ahfb-img-wrapper-main",
        alt: "Embedded Image"
      }));
    }

    return /*#__PURE__*/React.createElement("img", {
      src: props.data.config.url,
      className: "ahfb-img-wrapper-main ahfb-width-full"
    });
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "ahfb-width-full"
  }, renderTooltip());
}