import React from 'react';
import LinkIcon from '@material-ui/icons/Launch';
export default function VideoWrapper(props) {
  var extractVideoId = function extractVideoId(url) {
    // Regular expression to match YouTube video IDs in various URL formats
    var regex = /^(?:https?:\/\/)?(?:www\.)?(?:youtube\.com\/(?:watch\?.*v=|embed\/|v\/)|youtu\.be\/)([\w-]{11})(&(?:.*))?$/; // Match the URL against the regular expression

    var match = url.match(regex);

    if (match && match[1]) {
      return match[1]; // Return the extracted video ID
    }

    return null; // Return null if no match was found
  };

  var renderLink = function renderLink() {
    if (props.data.config.href) {
      return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("a", {
        href: props.data.config.href,
        target: "_blank",
        rel: "noopener noreferrer"
      }, /*#__PURE__*/React.createElement(LinkIcon, null)), /*#__PURE__*/React.createElement("video", {
        className: "ahfb-width-full",
        autoPlay: !!props.data.config.autoPlay,
        controls: true
      }, /*#__PURE__*/React.createElement("source", {
        src: props.data.config.url
      })));
    } else if (props.data.config.subType === 'youtube') {
      var embeddedUrl = "https://www.youtube.com/embed/" + extractVideoId(props.data.config.url);
      return /*#__PURE__*/React.createElement("iframe", {
        id: "youtube-video",
        className: "ahfb-iframe",
        title: props.data.config.url,
        src: embeddedUrl,
        frameBorder: "0",
        allow: "accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture",
        allowFullScreen: true
      });
    } else {
      return /*#__PURE__*/React.createElement("video", {
        className: "ahfb-width-full",
        controls: true
      }, /*#__PURE__*/React.createElement("source", {
        src: props.data.config.url
      }));
    }
  };

  return /*#__PURE__*/React.createElement("div", {
    className: props.data.config.subType === 'youtube' ? "afhb-iframe-wrapper" : "ahfb-width-full"
  }, renderLink());
}