import React, { useEffect } from 'react';
import { makeStyles } from '@material-ui/core/styles';
import AppBar from '@material-ui/core/AppBar';
import Toolbar from '@material-ui/core/Toolbar';
import Typography from '@material-ui/core/Typography';
import Divider from '@material-ui/core/Divider';
var useStyles = makeStyles(function (theme) {
  return {
    titleCenter: {
      flexGrow: 1,
      textAlign: 'center'
    },
    titleWithAction: {
      flexGrow: 1
    },
    drawerPaper: {
      width: '32%'
    }
  };
});
export default function PersistentDrawerRight(props) {
  var classes = useStyles();
  useEffect(function () {
    window.onscroll = function () {
      fixToolbar();
    };
  });

  var fixToolbar = function fixToolbar() {
    var header = document.getElementById("toolbar-main");
    var sticky = header.offsetTop;

    if (window.pageYOffset > sticky) {
      header.classList.add("sticky");
    } else {
      header.classList.remove("sticky");
    }
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "ahfb-toolbar-main",
    id: "toolbar-main"
  }, /*#__PURE__*/React.createElement(AppBar, {
    className: "ahfb-position-static"
  }, /*#__PURE__*/React.createElement(Toolbar, null, /*#__PURE__*/React.createElement(Typography, {
    variant: "h6",
    noWrap: true,
    className: !!props.rightIcon ? classes.titleWithAction : classes.titleCenter + " toolBarTitle"
  }, props.title, !!props.rightIcon ? /*#__PURE__*/React.createElement("span", {
    className: "ahfb-pull-right ahfb-cursor-pointer"
  }, props.rightIcon) : ""))), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement("div", {
    className: props.type === 'fields' ? "ahfb-toolbar-inner-paper ahfb-toolbar-field-types" : "ahfb-toolbar-inner-paper"
  }, props.children));
}