function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { connect } from "react-redux";
import TextField from "./field-forms/TextField";
import Checkbox from "./field-forms/Checkbox";
import Content from "./field-forms/Content";
import Date from "./field-forms/Date";
import File from "./field-forms/File";
import Image from "./field-forms/Image";
import List from "./field-forms/List";
import Quiz from "./field-forms/Quiz";
import Select from "./field-forms/Select";
import Signature from "./field-forms/Signature";
import Survey from "./field-forms/Survey";
import Video from "./field-forms/Video";
import Radio from "./field-forms/Radio";
import Section from "./field-forms/Section";
import _ from 'lodash';

function EditField(props) {
  var field = {};

  if (props.newFieldData) {
    field = _.cloneDeep(props.newFieldData);
  } else {
    field = _.cloneDeep(props.data[props.editId]);
    if (field.locals && Object.keys(field.locals).length) Object.keys(field.locals).forEach(function (local) {
      if (local && Object.keys(local).length) field.config = _extends({}, field.config, field.locals[local]);
    });
  }

  var renderFieldForms = function renderFieldForms() {
    switch (field.type) {
      case 'checkbox':
        return /*#__PURE__*/React.createElement(Checkbox, {
          data: field
        });

      case 'radio':
        return /*#__PURE__*/React.createElement(Radio, {
          data: field
        });

      case 'content':
        return /*#__PURE__*/React.createElement(Content, {
          data: field
        });

      case 'date':
        return /*#__PURE__*/React.createElement(Date, {
          data: field
        });

      case 'file':
        return /*#__PURE__*/React.createElement(File, {
          data: field
        });

      case 'image':
        return /*#__PURE__*/React.createElement(Image, {
          data: field
        });

      case 'list':
        return /*#__PURE__*/React.createElement(List, {
          data: field
        });

      case 'quiz':
        return /*#__PURE__*/React.createElement(Quiz, {
          data: field
        });

      case 'select':
        return /*#__PURE__*/React.createElement(Select, {
          data: field
        });

      case 'signature':
        return /*#__PURE__*/React.createElement(Signature, {
          data: field
        });

      case 'survey':
        return /*#__PURE__*/React.createElement(Survey, {
          data: field
        });

      case 'text':
        return /*#__PURE__*/React.createElement(TextField, {
          data: field
        });

      case 'video':
        return /*#__PURE__*/React.createElement(Video, {
          data: field
        });

      case 'section':
        return /*#__PURE__*/React.createElement(Section, {
          data: field
        });

      default:
        return /*#__PURE__*/React.createElement("div", null, "Something magical happened");
    }
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "position-relative ahfb-width-full"
  }, renderFieldForms());
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    newFieldData: state.form.newFieldData,
    editId: state.toolbar.editId,
    data: state.form.data
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {};
};

export default connect(mapStateToProps, mapDispatchToProps)(EditField);