function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useCallback, useEffect } from "react";
import FormLabel from "@material-ui/core/FormLabel";
import FormControl from "@material-ui/core/FormControl";
import { makeStyles } from "@material-ui/core/styles";
import FormHelperText from "@material-ui/core/FormHelperText";
import IconButton from "@material-ui/core/IconButton";
import DragIcon from "@material-ui/icons/DragIndicator";
import AddIcon from "@material-ui/icons/AddCircleOutline";
import RemoveIcon from "@material-ui/icons/RemoveCircleOutline";
import TextInput from "../inputs/TextInput";
import { Grid, List, ListItem, ListItemIcon } from "@material-ui/core";
import _ from "lodash";
import { sortableContainer, sortableElement, sortableHandle } from "react-sortable-hoc";
import arrayMove from "array-move";
import DoneIcon from "@material-ui/icons/Done";
import CancelIcon from "@material-ui/icons/Cancel";
import "./style.scss";
import { generateUUID, getUniqueNumber, stringToSlug } from '../helpers';
import ChoiceItem from "./ChoiceItem";
import { Scrollbars } from "react-custom-scrollbars";
import axios from "axios";
import { updateCategoryOptions as _updateCategoryOptions } from "../../actions/predefinedActions";
import { connect } from "react-redux";
var newLabel = {
  en: "New Label",
  ar: "تسمية جديدة"
};
var newValue = {
  en: "New Value",
  ar: "قيمة جديدة"
};
var useStyles = makeStyles(function (theme) {
  return {
    labelRoot: {
      transform: "none"
    }
  };
});

function Choices(props) {
  var error = props.error,
      required = props.required,
      label = props.label;

  var _React$useState = React.useState(null),
      name = _React$useState[0],
      setName = _React$useState[1];

  var _React$useState2 = React.useState(null),
      value = _React$useState2[0],
      setValue = _React$useState2[1];

  var _React$useState3 = React.useState(null),
      index = _React$useState3[0],
      setIndex = _React$useState3[1];

  var _React$useState4 = React.useState("name"),
      fieldFocus = _React$useState4[0],
      setFieldFocus = _React$useState4[1];

  var _React$useState5 = React.useState(""),
      labelError = _React$useState5[0],
      setLabelError = _React$useState5[1];

  var _React$useState6 = React.useState({
    options: []
  }),
      predefined = _React$useState6[0],
      setPredefined = _React$useState6[1];

  var classes = useStyles();
  var newField = false; // let predefined = {options: []};

  useEffect(function () {
    if (props.optionReferenceId) {
      for (var i = 0; i < props.predefined.length; i++) {
        if (props.predefined[i].id === props.optionReferenceId) {
          setPredefined(props.predefined[i]);
          break;
        }
      }
    }
  }, [props.predefined, props.optionReferenceId]);

  if (predefined.options.length === 0) {
    newField = true;
  }

  var _handleChange = function handleChange(val, name) {
    if (name === "name") {
      setName(val.replace(/\s+/g, ' ') !== ' ' ? val.replace(/\s+/g, ' ') : null);
      setFieldFocus(name);
    } else if (name === "value") {
      setValue(val.replace(/\s+/g, ' ') !== ' ' ? val.replace(/\s+/g, ' ') : null);
      setFieldFocus(name);
    } else {
      setName(null);
      setValue(null);
      setIndex(val);
    }

    setLabelError("");
  };

  var addNewChoice = function addNewChoice(e) {
    e.preventDefault();
    actionPerformed().then(function (resPredefined) {
      if (name !== null || '') {
        var newOpt = {
          id: getUniqueNumber(),
          saveType: 'new',
          name: name,
          value: value || name,
          order: index != null ? index : 0
        };
        var updatedOptions = [].concat(resPredefined.options.slice(0, index), [newOpt], resPredefined.options.slice(index, resPredefined.options.length));
        props.updateCategoryOptions(updatedOptions, resPredefined.slug);
        disableNewChoice();
        setFieldFocus("name");
      } // const newOpt = {
      //   id: getUniqueNumber(),
      //   saveType: 'new',
      //   name,
      //   value,
      //   order: index ?? 0,
      // }
      // const updatedOptions = [
      //   ...resPredefined.options.slice(0, index),
      //   newOpt,
      //     ...resPredefined.options.slice(index, resPredefined.options.length)
      // ]
      // props.updateCategoryOptions(updatedOptions, resPredefined.slug);
      // disableNewChoice();
      // setFieldFocus("name");
      // let url = "/predefined";
      // if (props.predefinedEndpoint) {
      //   url = props.predefinedEndpoint;
      // }
      // axios
      //   .post(url + "/" + resPredefined.id + "/options", {
      //     name,
      //     value,
      //     order: index,
      //   })
      //   .then((res) => {
      //     props.updateCategoryOptions(res.data.options, resPredefined.slug);
      //     disableNewChoice();
      //     setFieldFocus("name");
      //   });

    })["catch"](function (err) {
      console.log(err);
    });
  };

  var deleteChoice = function deleteChoice(optionId) {
    actionPerformed().then(function (resPredefined) {
      var updatedOpt = resPredefined.options.filter(function (item) {
        return item.id !== optionId;
      });
      props.updateCategoryOptions(updatedOpt, resPredefined.slug);
      disableNewChoice(); // let url = "/predefined";
      // if (props.predefinedEndpoint) {
      //   url = props.predefinedEndpoint;
      // }
      // axios
      //   .delete(url + "/" + resPredefined.id + "/options/" + optionId)
      //   .then((res) => {
      //     props.updateCategoryOptions(res.data.options, resPredefined.slug);
      //     disableNewChoice();
      //   });
    });
  };

  var disableNewChoice = function disableNewChoice() {
    setValue(null);
    setName(null);
    setIndex(null);
  };

  var actionPerformed = function actionPerformed() {
    return new Promise(function (resolve, reject) {
      if (!(predefined != null && predefined.id)) {
        props.disablePredefined().then(function (res) {
          resolve(res);
        });
      } else {
        resolve(predefined);
      }
    });
  };

  var _updateChoice = function updateChoice(label, oldLabel) {
    if (oldLabel !== label) {
      actionPerformed().then(function (resPredefined) {
        var updatedOpt = resPredefined.options.map(function (item) {
          if (item.name === oldLabel && label.trim() !== '') {
            return _extends({}, item, {
              name: label
            });
          }

          return item;
        });
        props.updateCategoryOptions(updatedOpt, resPredefined.slug);
        disableNewChoice();
      });
    }
  };

  var renderAddChoice = function renderAddChoice() {
    return /*#__PURE__*/React.createElement("form", {
      onSubmit: addNewChoice,
      className: "ahfb-ml-4 ahfb-width-full"
    }, /*#__PURE__*/React.createElement(Grid, {
      container: true
    }, /*#__PURE__*/React.createElement(Grid, {
      item: true,
      xs: 5,
      className: "ahfb-pr-1 ahfb-mr-1"
    }, /*#__PURE__*/React.createElement(TextInput, {
      autoFocus: fieldFocus === "name",
      placeholder: newLabel[props.currentLang],
      error: labelError,
      value: name,
      handleChange: function handleChange(e) {
        return _handleChange(e.target.value, "name");
      }
    })), /*#__PURE__*/React.createElement(Grid, {
      item: true,
      xs: 5,
      className: "ahfb-px-1 ahfb-pr-4"
    }, /*#__PURE__*/React.createElement(TextInput, {
      autoFocus: fieldFocus === "value",
      placeholder: newValue[props.currentLang],
      value: value,
      handleChange: function handleChange(e) {
        return _handleChange(e.target.value, "value");
      }
    })), /*#__PURE__*/React.createElement(Grid, {
      item: true,
      xs: 1,
      className: "ahfb-d-flex"
    }, /*#__PURE__*/React.createElement(IconButton, {
      size: "small",
      onClick: addNewChoice,
      type: "submit"
    }, /*#__PURE__*/React.createElement(DoneIcon, null)), !newField ? /*#__PURE__*/React.createElement(IconButton, {
      size: "small",
      onClick: disableNewChoice
    }, /*#__PURE__*/React.createElement(CancelIcon, null)) : "")));
  };

  var DragHandle = sortableHandle(function () {
    return /*#__PURE__*/React.createElement(DragIcon, {
      className: "ahfb-mt-4"
    });
  });

  var renderChoice = function renderChoice(choice, listIndex) {
    if (listIndex === index) {
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(ListItem, {
        disableGutters: true,
        className: "ahfb-py-0 ahfb-width-98p ahfb-my-2 ahfb-mx-4 ",
        key: choice.id + "-new"
      }, renderAddChoice()), /*#__PURE__*/React.createElement(ListItem, {
        disableGutters: true,
        className: "ahfb-py-0 ahfb-width-98p",
        key: choice.id
      }, /*#__PURE__*/React.createElement(ListItemIcon, {
        className: "choices-drag-icon"
      }, !predefined.is_secure && /*#__PURE__*/React.createElement(DragHandle, null)), /*#__PURE__*/React.createElement(ChoiceItem, {
        disabled: predefined.is_secure,
        inputProps: true,
        label: choice.name,
        updateChoice: function updateChoice(value) {
          return _updateChoice(value, choice.name);
        },
        index: listIndex
      }), !predefined.is_secure && /*#__PURE__*/React.createElement(IconButton, {
        size: "small",
        className: "ahfb-mt-3",
        onClick: function onClick(e) {
          return _handleChange(listIndex + 1, "index");
        }
      }, /*#__PURE__*/React.createElement(AddIcon, null)), !predefined.is_secure && /*#__PURE__*/React.createElement(IconButton, {
        size: "small",
        className: "ahfb-mt-3",
        onClick: function onClick(e) {
          return deleteChoice(choice.id);
        }
      }, /*#__PURE__*/React.createElement(RemoveIcon, null))));
    } else if (index === predefined.options.length && listIndex === predefined.options.length - 1) {
      return /*#__PURE__*/React.createElement(React.Fragment, {
        key: choice.name
      }, /*#__PURE__*/React.createElement(ListItem, {
        disableGutters: true,
        className: "ahfb-py-0 ahfb-width-98p"
      }, /*#__PURE__*/React.createElement(ListItemIcon, {
        className: "choices-drag-icon"
      }, !predefined.is_secure && /*#__PURE__*/React.createElement(DragHandle, null)), /*#__PURE__*/React.createElement(ChoiceItem, {
        disabled: predefined.is_secure,
        label: choice.name,
        updateChoice: function updateChoice(value) {
          return _updateChoice(value, choice.name);
        },
        index: listIndex
      }), !predefined.is_secure && /*#__PURE__*/React.createElement(IconButton, {
        size: "small",
        className: "ahfb-mt-3",
        onClick: function onClick(e) {
          return _handleChange(listIndex + 1, "index");
        }
      }, /*#__PURE__*/React.createElement(AddIcon, null)), !predefined.is_secure && /*#__PURE__*/React.createElement(IconButton, {
        size: "small",
        className: "ahfb-mt-3",
        onClick: function onClick(e) {
          return deleteChoice(choice.id);
        }
      }, /*#__PURE__*/React.createElement(RemoveIcon, null))), /*#__PURE__*/React.createElement(ListItem, {
        disableGutters: true,
        className: "ahfb-py-0 ahfb-width-98p ahfb-my-2 ahfb-mx-4",
        key: choice.name + "-new"
      }, renderAddChoice()));
    } else {
      return /*#__PURE__*/React.createElement(ListItem, {
        disableGutters: true,
        className: "ahfb-py-0 ahfb-width-98p",
        key: choice.name
      }, /*#__PURE__*/React.createElement(ListItemIcon, {
        className: "choices-drag-icon"
      }, !predefined.is_secure && /*#__PURE__*/React.createElement(DragHandle, null)), /*#__PURE__*/React.createElement(ChoiceItem, {
        disabled: predefined.is_secure,
        label: choice.name,
        updateChoice: function updateChoice(value) {
          return _updateChoice(value, choice.name);
        },
        index: listIndex
      }), !predefined.is_secure && /*#__PURE__*/React.createElement(IconButton, {
        size: "small",
        className: "ahfb-mt-3",
        onClick: function onClick(e) {
          return _handleChange(listIndex + 1, "index");
        }
      }, /*#__PURE__*/React.createElement(AddIcon, null)), !predefined.is_secure && /*#__PURE__*/React.createElement(IconButton, {
        size: "small",
        className: "ahfb-mt-3",
        onClick: function onClick(e) {
          return deleteChoice(choice.id);
        }
      }, /*#__PURE__*/React.createElement(RemoveIcon, null)));
    }
  };

  var SortableItem = sortableElement(function (_ref) {
    var listIndex = _ref.listIndex,
        value = _ref.value;
    return renderChoice(value, listIndex);
  });

  var onSortEnd = function onSortEnd(_ref2) {
    var oldIndex = _ref2.oldIndex,
        newIndex = _ref2.newIndex;
    var sortedOptions = arrayMove(predefined.options, oldIndex, newIndex).map(function (option, index) {
      option.order = index;
      return option;
    });
    setPredefined(_extends({}, predefined, {
      options: sortedOptions
    }));
    props.updateCategoryOptions(sortedOptions, predefined.slug); //
    // let url = "/predefined";
    // if (props.predefinedEndpoint) {
    //   url = props.predefinedEndpoint;
    // }
    // axios
    //   .put(url + "/" + "reorder-options/" + props.optionReferenceId, {
    //     options: sortedOptions,
    //   })
    //   .then((res) => {
    //     props.updateCategoryOptions(res.data.options, predefined.slug);
    //   });
  };

  var SortableContainer = sortableContainer(function (_ref3) {
    var children = _ref3.children;
    return /*#__PURE__*/React.createElement(List, null, children);
  });

  var renderChoices = function renderChoices() {
    return /*#__PURE__*/React.createElement(SortableContainer, {
      onSortEnd: onSortEnd,
      useDragHandle: true
    }, predefined.options.map(function (choice, listIndex) {
      return /*#__PURE__*/React.createElement(SortableItem, {
        key: "item-" + choice.id,
        index: listIndex,
        listIndex: listIndex,
        value: choice
      });
    }));
  };

  return /*#__PURE__*/React.createElement(FormControl, {
    error: !!error,
    fullWidth: true
  }, /*#__PURE__*/React.createElement(FormLabel, {
    required: required
  }, label), newField ? /*#__PURE__*/React.createElement("div", {
    className: "ahfb-my-2 ahfb-mx-4"
  }, renderAddChoice(), " ") : renderChoices(), !!error ? /*#__PURE__*/React.createElement(FormHelperText, null, error) : "");
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    predefinedEndpoint: state.form.predefinedEndpoint,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    updateCategoryOptions: function updateCategoryOptions(data, slug) {
      return dispatch(_updateCategoryOptions(data, slug));
    }
  };
};

export default connect(mapStateToProps, mapDispatchToProps)(Choices);