import React from 'react';
import { makeStyles } from '@material-ui/core/styles';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import FormControl from "@material-ui/core/FormControl";
import FormLabel from "@material-ui/core/FormLabel";
import FormHelperText from "@material-ui/core/FormHelperText";
import _ from 'lodash';
import RadioGroup from "@material-ui/core/RadioGroup";
import Radio from "@material-ui/core/Radio";
export default function CustomRadioGroup(props) {
  var options = props.options,
      value = props.value,
      handleChange = props.handleChange,
      label = props.label,
      error = props.error,
      required = props.required,
      helperText = props.helperText,
      disabled = props.disabled;
  var labelProp = props.labelProp ? props.labelProp : 'label';
  var valueProp = props.valueProp ? props.valueProp : 'value';
  return /*#__PURE__*/React.createElement(FormControl, {
    required: required,
    error: error,
    component: "fieldset",
    disabled: disabled
  }, /*#__PURE__*/React.createElement(FormLabel, {
    component: "label"
  }, label), /*#__PURE__*/React.createElement(RadioGroup, {
    value: value,
    onChange: handleChange
  }, options.map(function (option) {
    return /*#__PURE__*/React.createElement(FormControlLabel, {
      key: 'option-' + option[valueProp],
      control: /*#__PURE__*/React.createElement(Radio, {
        value: option[valueProp]
      }),
      label: option[labelProp]
    });
  })), /*#__PURE__*/React.createElement(FormHelperText, null, error ? error : helperText ? helperText : ''));
}