import React, { useState } from 'react';
import { connect } from 'react-redux';
import ExpansionPanel from '@material-ui/core/ExpansionPanel';
import ExpansionPanelSummary from '@material-ui/core/ExpansionPanelSummary';
import ExpansionPanelDetails from '@material-ui/core/ExpansionPanelDetails';
import Typography from '@material-ui/core/Typography';
import ExpandMoreIcon from '@material-ui/icons/ExpandMore';
import Divider from '@material-ui/core/Divider';
import Wrapper from '../../components/app/FieldWrapper';
import _ from 'lodash';

function Section(props) {
  var name = props.name,
      uuid = props.uuid,
      collapseable = props.collapseable;

  var _useState = useState(true),
      expand = _useState[0],
      setExpand = _useState[1];

  var renderFields = function renderFields() {
    var fields = Object.values(props.data);
    var sectionFields = fields.filter(function (field) {
      if (field.parentId === uuid) return true;
      return false;
    });
    if (!sectionFields.length) return /*#__PURE__*/React.createElement("div", {
      style: {
        textAlign: 'center'
      }
    }, /*#__PURE__*/React.createElement("small", null, " Drop fields here"));
    return _.map(sectionFields, function (field, index) {
      return /*#__PURE__*/React.createElement(ExpansionPanelDetails, {
        style: {
          padding: 0
        }
      }, /*#__PURE__*/React.createElement("div", {
        style: {
          width: '100%'
        }
      }, /*#__PURE__*/React.createElement("li", {
        key: 'li-' + field.uuid,
        className: "d-block container-fluid"
      }, /*#__PURE__*/React.createElement(Wrapper, {
        data: field,
        key: field.uuid
      }))));
    });
  };

  var handleChange = function handleChange() {
    if (collapseable) setExpand(!expand);
  };

  return /*#__PURE__*/React.createElement("div", {
    style: {
      marginTop: 10
    }
  }, /*#__PURE__*/React.createElement(ExpansionPanel, {
    elevation: 0,
    onChange: handleChange,
    expanded: expand
  }, /*#__PURE__*/React.createElement(ExpansionPanelSummary, {
    expandIcon: collapseable ? /*#__PURE__*/React.createElement(ExpandMoreIcon, null) : '',
    "aria-controls": "panel1a-content",
    id: "panel1a-header",
    style: {
      padding: 0
    }
  }, /*#__PURE__*/React.createElement(Typography, null, name)), expand ? /*#__PURE__*/React.createElement("hr", null) : '', renderFields()));
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    data: state.form.data,
    order: state.form.order
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setOrder: function (_setOrder) {
      function setOrder(_x) {
        return _setOrder.apply(this, arguments);
      }

      setOrder.toString = function () {
        return _setOrder.toString();
      };

      return setOrder;
    }(function (data) {
      return dispatch(setOrder(data));
    })
  };
};

export default connect(mapStateToProps)(Section);