"use strict";

exports.__esModule = true;
exports["default"] = ImageWrapper;

var _react = _interopRequireDefault(require("react"));

var _core = require("@material-ui/core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ImageWrapper(props) {
  var renderTooltip = function renderTooltip() {
    if (props.data.config.tooltip && props.data.config.tooltip !== '') {
      return /*#__PURE__*/_react["default"].createElement(_core.Tooltip, {
        title: props.data.config.tooltip
      }, renderLink());
    } else {
      return renderLink();
    }
  };

  var renderLink = function renderLink() {
    if (props.data.config.href) {
      return /*#__PURE__*/_react["default"].createElement("a", {
        href: props.data.config.href,
        target: "_blank",
        rel: "noopener noreferrer"
      }, /*#__PURE__*/_react["default"].createElement("img", {
        src: props.data.config.url,
        className: "ahfb-img-wrapper-main",
        alt: "Embedded Image"
      }));
    }

    return /*#__PURE__*/_react["default"].createElement("img", {
      src: props.data.config.url,
      className: "ahfb-img-wrapper-main ahfb-width-full"
    });
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "ahfb-width-full"
  }, renderTooltip());
}

module.exports = exports.default;