"use strict";

exports.__esModule = true;
exports["default"] = RadioWrapper;

var _react = _interopRequireDefault(require("react"));

var _RadioGroup = _interopRequireDefault(require("../../../utils/radio/RadioGroup"));

var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function RadioWrapper(props) {
  var _props$data2;

  var _React$useState = _react["default"].useState(null),
      value = _React$useState[0],
      setValue = _React$useState[1];

  var _React$useState2 = _react["default"].useState(false),
      other = _React$useState2[0],
      setOther = _React$useState2[1];

  var _React$useState3 = _react["default"].useState(''),
      otherValue = _React$useState3[0],
      setOtherValue = _React$useState3[1];

  var handleChange = function handleChange(e) {
    var newValue = e.target.value;

    if (newValue === 'Specify Others') {
      setOther(true);
    } else {
      setOther(false);
      setOtherValue('');
    }

    setValue(newValue);
  };

  var handleOtherChange = function handleOtherChange(e) {
    setOtherValue(e.target.value);
  };

  var options = [];

  if (props.data.config.optionReferenceId) {
    options = _.cloneDeep(props.predefined[props.data.config.optionReferenceId].options);
  }

  if (props.data.config.enableOther) {
    options.push({
      id: -1,
      name: 'Specify Others'
    });
  }

  if (other) {
    var _props$data;

    return [/*#__PURE__*/_react["default"].createElement(_RadioGroup["default"], {
      label: (_props$data = props.data) != null && _props$data.locals && Object.keys(props.data.locals).length !== 0 ? props.currentLang === 'en' ? props.data.name : props.data.locals.ar.name_ar : props.data.name,
      required: props.data.config.isRequired,
      helperText: props.data.config.helpText,
      options: options,
      labelProp: "name",
      valueProp: "name",
      value: value,
      handleChange: handleChange
    }), /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
      handleChange: handleOtherChange,
      value: otherValue,
      placeholder: "Specify Others"
    })];
  }

  return /*#__PURE__*/_react["default"].createElement(_RadioGroup["default"], {
    label: (_props$data2 = props.data) != null && _props$data2.locals && Object.keys(props.data.locals).length !== 0 ? props.currentLang === 'en' ? props.data.name : props.data.locals.ar.name_ar : props.data.name,
    required: props.data.config.isRequired,
    helperText: props.data.config.helpText,
    options: options,
    labelProp: "name",
    valueProp: "name",
    value: value,
    handleChange: handleChange
  });
}

module.exports = exports.default;