"use strict";

exports.__esModule = true;
exports["default"] = PersistentDrawerRight;

var _react = _interopRequireWildcard(require("react"));

var _styles = require("@material-ui/core/styles");

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    titleCenter: {
      flexGrow: 1,
      textAlign: 'center'
    },
    titleWithAction: {
      flexGrow: 1
    },
    drawerPaper: {
      width: '32%'
    }
  };
});

function PersistentDrawerRight(props) {
  var classes = useStyles();
  (0, _react.useEffect)(function () {
    window.onscroll = function () {
      fixToolbar();
    };
  });

  var fixToolbar = function fixToolbar() {
    var header = document.getElementById("toolbar-main");
    var sticky = header.offsetTop;

    if (window.pageYOffset > sticky) {
      header.classList.add("sticky");
    } else {
      header.classList.remove("sticky");
    }
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "ahfb-toolbar-main",
    id: "toolbar-main"
  }, /*#__PURE__*/_react["default"].createElement(_AppBar["default"], {
    className: "ahfb-position-static"
  }, /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], null, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
    variant: "h6",
    noWrap: true,
    className: !!props.rightIcon ? classes.titleWithAction : classes.titleCenter + " toolBarTitle"
  }, props.title, !!props.rightIcon ? /*#__PURE__*/_react["default"].createElement("span", {
    className: "ahfb-pull-right ahfb-cursor-pointer"
  }, props.rightIcon) : ""))), /*#__PURE__*/_react["default"].createElement(_Divider["default"], null), /*#__PURE__*/_react["default"].createElement("div", {
    className: props.type === 'fields' ? "ahfb-toolbar-inner-paper ahfb-toolbar-field-types" : "ahfb-toolbar-inner-paper"
  }, props.children));
}

module.exports = exports.default;