"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _TextField = _interopRequireDefault(require("./field-forms/TextField"));

var _Checkbox = _interopRequireDefault(require("./field-forms/Checkbox"));

var _Content = _interopRequireDefault(require("./field-forms/Content"));

var _Date = _interopRequireDefault(require("./field-forms/Date"));

var _File = _interopRequireDefault(require("./field-forms/File"));

var _Image = _interopRequireDefault(require("./field-forms/Image"));

var _List = _interopRequireDefault(require("./field-forms/List"));

var _Quiz = _interopRequireDefault(require("./field-forms/Quiz"));

var _Select = _interopRequireDefault(require("./field-forms/Select"));

var _Signature = _interopRequireDefault(require("./field-forms/Signature"));

var _Survey = _interopRequireDefault(require("./field-forms/Survey"));

var _Video = _interopRequireDefault(require("./field-forms/Video"));

var _Radio = _interopRequireDefault(require("./field-forms/Radio"));

var _Section = _interopRequireDefault(require("./field-forms/Section"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function EditField(props) {
  var field = {};

  if (props.newFieldData) {
    field = _lodash["default"].cloneDeep(props.newFieldData);
  } else {
    field = _lodash["default"].cloneDeep(props.data[props.editId]);
    if (field.locals && Object.keys(field.locals).length) Object.keys(field.locals).forEach(function (local) {
      if (local && Object.keys(local).length) field.config = _extends({}, field.config, field.locals[local]);
    });
  }

  var renderFieldForms = function renderFieldForms() {
    switch (field.type) {
      case 'checkbox':
        return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          data: field
        });

      case 'radio':
        return /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          data: field
        });

      case 'content':
        return /*#__PURE__*/_react["default"].createElement(_Content["default"], {
          data: field
        });

      case 'date':
        return /*#__PURE__*/_react["default"].createElement(_Date["default"], {
          data: field
        });

      case 'file':
        return /*#__PURE__*/_react["default"].createElement(_File["default"], {
          data: field
        });

      case 'image':
        return /*#__PURE__*/_react["default"].createElement(_Image["default"], {
          data: field
        });

      case 'list':
        return /*#__PURE__*/_react["default"].createElement(_List["default"], {
          data: field
        });

      case 'quiz':
        return /*#__PURE__*/_react["default"].createElement(_Quiz["default"], {
          data: field
        });

      case 'select':
        return /*#__PURE__*/_react["default"].createElement(_Select["default"], {
          data: field
        });

      case 'signature':
        return /*#__PURE__*/_react["default"].createElement(_Signature["default"], {
          data: field
        });

      case 'survey':
        return /*#__PURE__*/_react["default"].createElement(_Survey["default"], {
          data: field
        });

      case 'text':
        return /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
          data: field
        });

      case 'video':
        return /*#__PURE__*/_react["default"].createElement(_Video["default"], {
          data: field
        });

      case 'section':
        return /*#__PURE__*/_react["default"].createElement(_Section["default"], {
          data: field
        });

      default:
        return /*#__PURE__*/_react["default"].createElement("div", null, "Something magical happened");
    }
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "position-relative ahfb-width-full"
  }, renderFieldForms());
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    newFieldData: state.form.newFieldData,
    editId: state.toolbar.editId,
    data: state.form.data
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {};
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(EditField);

exports["default"] = _default;
module.exports = exports.default;