"use strict";

exports.__esModule = true;
exports["default"] = AlertDialog;

var _react = _interopRequireDefault(require("react"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Dialog = _interopRequireDefault(require("@material-ui/core/Dialog"));

var _DialogActions = _interopRequireDefault(require("@material-ui/core/DialogActions"));

var _DialogContent = _interopRequireDefault(require("@material-ui/core/DialogContent"));

var _DialogTitle = _interopRequireDefault(require("@material-ui/core/DialogTitle"));

var _DialogContentText = _interopRequireDefault(require("@material-ui/core/DialogContentText"));

var _core = require("@material-ui/core");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function AlertDialog(props) {
  var open = props.open,
      title = props.title,
      message = props.message,
      primaryLabel = props.primaryLabel,
      secondaryLabel = props.secondaryLabel,
      primaryAction = props.primaryAction,
      secondaryAction = props.secondaryAction,
      primaryActionLoading = props.primaryActionLoading,
      secondaryActionLoading = props.secondaryActionLoading;
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_Dialog["default"], {
    open: open,
    onClose: secondaryAction,
    fullWidth: true,
    classes: {
      paper: 'rounded-8'
    }
  }, /*#__PURE__*/_react["default"].createElement(_DialogTitle["default"], null, /*#__PURE__*/_react["default"].createElement(_core.Typography, {
    className: "text-14",
    variant: "h6"
  }, title || '')), /*#__PURE__*/_react["default"].createElement(_DialogContent["default"], null, /*#__PURE__*/_react["default"].createElement(_DialogContentText["default"], null, message)), /*#__PURE__*/_react["default"].createElement(_DialogActions["default"], null, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    disabled: !!secondaryActionLoading,
    onClick: secondaryAction,
    color: "secondary",
    variant: "outlined"
  }, !!secondaryActionLoading && /*#__PURE__*/_react["default"].createElement(_core.CircularProgress, {
    size: "2.4rem",
    className: "mr-4 rtl:ml-4",
    color: "secondary"
  }), secondaryLabel), primaryLabel ? /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    disabled: !!primaryActionLoading,
    onClick: primaryAction,
    autoFocus: true,
    variant: "contained"
  }, !!primaryActionLoading && /*#__PURE__*/_react["default"].createElement(_core.CircularProgress, {
    size: "2.4rem",
    className: "mr-4 rtl:ml-4",
    color: "secondary"
  }), primaryLabel) : '')));
}

module.exports = exports.default;