"use strict";

exports.__esModule = true;
exports["default"] = CheckboxGroup;

var _react = _interopRequireDefault(require("react"));

var _styles = require("@material-ui/core/styles");

var _FormGroup = _interopRequireDefault(require("@material-ui/core/FormGroup"));

var _FormControlLabel = _interopRequireDefault(require("@material-ui/core/FormControlLabel"));

var _Checkbox = _interopRequireDefault(require("@material-ui/core/Checkbox"));

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _FormLabel = _interopRequireDefault(require("@material-ui/core/FormLabel"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function CheckboxGroup(props) {
  var row = props.row,
      options = props.options,
      value = props.value,
      handleChange = props.handleChange,
      label = props.label,
      error = props.error,
      required = props.required,
      helperText = props.helperText,
      disabled = props.disabled;
  var labelProp = props.labelProp ? props.labelProp : 'label';
  var valueProp = props.valueProp ? props.valueProp : 'value';

  var handleValueChange = function handleValueChange(val) {
    var newValue = _lodash["default"].cloneDeep(value);

    if (newValue.includes(val)) {
      newValue.splice(value.indexOf(val), 1);
    } else {
      newValue.push(val);
    }

    handleChange({
      target: {
        value: newValue
      }
    });
  };

  return /*#__PURE__*/_react["default"].createElement(_FormControl["default"], {
    required: required,
    error: error,
    component: "fieldset",
    disabled: disabled
  }, /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], {
    component: "label"
  }, label), /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], {
    row: row
  }, options.map(function (option) {
    return /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], {
      key: 'option-' + option[valueProp],
      control: /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
        checked: value.includes(option[valueProp]),
        onChange: function onChange(e) {
          return handleValueChange(option[valueProp]);
        },
        value: option[valueProp]
      }),
      label: option[labelProp]
    });
  })), /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], null, error ? error : helperText ? helperText : ''));
}

module.exports = exports.default;