"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("@material-ui/core/styles");

var _FormControl = _interopRequireDefault(require("@material-ui/core/FormControl"));

var _Input = _interopRequireDefault(require("@material-ui/core/Input"));

var _InputAdornment = _interopRequireDefault(require("@material-ui/core/InputAdornment"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

var _InputLabel = _interopRequireDefault(require("@material-ui/core/InputLabel"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    labelRoot: {
      transform: 'none'
    }
  };
});

var TextInput = function TextInput(props) {
  var value = props.value,
      handleChange = props.handleChange,
      required = props.required,
      inputProps = props.inputProps,
      helperText = props.helperText,
      error = props.error,
      startAdornment = props.startAdornment,
      endAdornment = props.endAdornment,
      label = props.label,
      placeholder = props.placeholder,
      disabled = props.disabled,
      autoFocus = props.autoFocus,
      type = props.type;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement(_FormControl["default"], {
    required: required,
    disabled: disabled,
    error: !!error,
    fullWidth: true
  }, label ? /*#__PURE__*/_react["default"].createElement(_InputLabel["default"], {
    required: required,
    shrink: true,
    classes: {
      shrink: classes.labelRoot
    }
  }, label) : "", /*#__PURE__*/_react["default"].createElement(_Input["default"], {
    autoFocus: !!autoFocus,
    placeholder: placeholder,
    value: value,
    onChange: handleChange,
    startAdornment: startAdornment ? /*#__PURE__*/_react["default"].createElement(_InputAdornment["default"], {
      position: "start"
    }, startAdornment) : null,
    endAdornment: endAdornment ? /*#__PURE__*/_react["default"].createElement(_InputAdornment["default"], {
      position: "end"
    }, endAdornment) : null,
    inputProps: inputProps,
    type: type ? type : 'text',
    onBlur: props.onBlur,
    classes: {
      root: classes.inputRoot
    }
  }), helperText ? /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], null, helperText) : "", !!error ? /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], {
    error: true
  }, error) : "");
};

var _default = TextInput;
exports["default"] = _default;
module.exports = exports.default;