"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _Dialog = _interopRequireDefault(require("@material-ui/core/Dialog"));

var _DialogActions = _interopRequireDefault(require("@material-ui/core/DialogActions"));

var _DialogContent = _interopRequireDefault(require("@material-ui/core/DialogContent"));

var _Toolbar = _interopRequireDefault(require("@material-ui/core/Toolbar"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Paper = _interopRequireDefault(require("@material-ui/core/Paper"));

var _reactDraggable = _interopRequireDefault(require("react-draggable"));

var _AppBar = _interopRequireDefault(require("@material-ui/core/AppBar"));

var _List = _interopRequireDefault(require("@material-ui/core/List"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _ListItemText = _interopRequireDefault(require("@material-ui/core/ListItemText"));

var _ListItemSecondaryAction = _interopRequireDefault(require("@material-ui/core/ListItemSecondaryAction"));

var _core = require("@material-ui/core");

var _Snackbar = _interopRequireDefault(require("@material-ui/core/Snackbar"));

var _Delete = _interopRequireDefault(require("@material-ui/icons/Delete"));

var _Add = _interopRequireDefault(require("@material-ui/icons/Add"));

var _Close = _interopRequireDefault(require("@material-ui/icons/Close"));

var _Done = _interopRequireDefault(require("@material-ui/icons/Done"));

var _lodash = _interopRequireDefault(require("lodash"));

var _axios = _interopRequireDefault(require("axios"));

var _reactRedux = require("react-redux");

require("./style.scss");

var _NewCategory = _interopRequireDefault(require("./NewCategory"));

var _predefinedActions = require("../../actions/predefinedActions");

var _helpers = require("../helpers");

var _NewOption = _interopRequireDefault(require("./NewOption"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var addLabel = {
  en: "Add Predefined Values",
  ar: "أضف قيمًا محددة مسبقًا"
};
var categoryLabel = {
  en: "Category",
  ar: "الفئة"
};
var cancelLabel = {
  en: "Cancel",
  ar: "إلغاء"
};
var insertLabel = {
  en: "Insert Choices",
  ar: "أدخل الاختيارات"
};
var noPredefinedLabel = {
  en: "There are no predefined categories available.",
  ar: "لا توجد فئات محددة مسبقا متاحة"
};
var noOptionsLabel = {
  en: "No options available",
  ar: "لا توجد خيارات متاحة"
};
var createNewOptionsLabel = {
  en: "Start Creating new options",
  ar: "ابدأ في إنشاء خيارات جديدة"
};
var viewOptionsLabel = {
  en: "Select a category to view its options",
  ar: "حدد فئة لعرض خياراتها"
};
var newCategoryLabel = {
  en: "New category successfully added.",
  ar: "تمت إضافة فئة جديدة بنجاح"
};
var divisionLabel = {
  en: "Divisions",
  ar: "الانقسامات"
};
var jobTitleLabel = {
  en: "Job Title",
  ar: "مسمى وظيفي"
};
var locationLabel = {
  en: "Locations",
  ar: "المواقع"
};

function PaperComponent(props) {
  return /*#__PURE__*/_react["default"].createElement(_reactDraggable["default"], {
    handle: "#draggable-dialog-title",
    cancel: '[class*="MuiDialogContent-root"]'
  }, /*#__PURE__*/_react["default"].createElement(_Paper["default"], props));
}

var PredefinedValues = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(PredefinedValues, _React$Component);

  function PredefinedValues(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleAddCategoryMsgClose", function () {
      _this.setState({
        showAddCategoryMsg: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClickOpen", function () {
      _this.setState({
        open: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function () {
      _this.setState({
        open: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleInsert", function () {
      if (_this.state.activeCategory) {
        _this.props.insertChoices(_this.state.activeCategory);

        _this.handleClose();
      } else {
        _this.setState({
          insertError: {
            en: "Select a category to insert options",
            ar: "حدد فئة لعرض خياراتها"
          }
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "enableCategory", function (category) {
      _this.setState({
        activeCategory: category,
        insertError: null
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleAddCategoryOpen", function () {
      _this.setState({
        addCategory: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleAddCategoryClose", function () {
      _this.setState({
        addCategory: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "saveNewCategory", function (categoryName) {
      var slug = (0, _helpers.stringToSlug)(categoryName);
      var data = {
        options: [],
        label: categoryName
      };

      _axios["default"].post(_this.props.predefinedEndpoint, {
        name: categoryName,
        slug: slug,
        isPublic: true
      }).then(function (res) {
        _this.props.addCategory(res.data);

        _this.setState({
          addCategory: false,
          showAddCategoryMsg: true
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "saveNewCategoryOption", function (name, value) {
      _axios["default"].post(_this.props.predefinedEndpoint + "/" + _this.state.activeCategory.id + "/options", {
        name: name,
        value: value
      }).then(function (res) {
        _this.props.updateCategoryOptions(res.data.options, _this.state.activeCategory.slug);

        _this.setState({
          activeCategory: _extends({}, _this.state.activeCategory, {
            options: res.data.options
          })
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "deleteOption", function (option) {
      _axios["default"]["delete"](_this.props.predefinedEndpoint + "/" + _this.state.activeCategory.id + "/options/" + option.id).then(function (res) {
        _this.props.updateCategoryOptions(res.data.options, _this.state.activeCategory.slug);

        _this.setState({
          activeCategory: _extends({}, _this.state.activeCategory, {
            options: res.data.options
          })
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderAddCategory", function () {
      if (_this.state.addCategory) {
        return /*#__PURE__*/_react["default"].createElement(_NewCategory["default"], {
          currentLang: _this.props.currentLang,
          names: _lodash["default"].map(_this.props.predefined, function (item) {
            return item.name.toLowerCase();
          }),
          saveNewCategory: _this.saveNewCategory,
          handleAddCategoryClose: _this.handleAddCategoryClose
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderAddOption", function () {
      if (_this.state.activeCategory && !_this.state.activeCategory.is_secure) {
        return /*#__PURE__*/_react["default"].createElement(_NewOption["default"], {
          saveNewCategoryOption: _this.saveNewCategoryOption,
          options: _this.state.activeCategory.options
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderCategories", function () {
      if (_lodash["default"].size(_this.props.predefined)) {
        return _lodash["default"].map(_this.props.predefined, function (category) {
          if (category.is_public) {
            if (category.name === "Divisions") {
              return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
                key: "category-" + category.slug,
                button: true,
                selected: _this.state.activeCategory && _this.state.activeCategory.slug === category.slug,
                onClick: function onClick(e) {
                  return _this.enableCategory(category);
                }
              }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
                primary: divisionLabel[_this.props.currentLang]
              }));
            } else if (category.name === "Job Titles") {
              return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
                key: "category-" + category.slug,
                button: true,
                selected: _this.state.activeCategory && _this.state.activeCategory.slug === category.slug,
                onClick: function onClick(e) {
                  return _this.enableCategory(category);
                }
              }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
                primary: jobTitleLabel[_this.props.currentLang]
              }));
            } else if (category.name === "Locations") {
              return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
                key: "category-" + category.slug,
                button: true,
                selected: _this.state.activeCategory && _this.state.activeCategory.slug === category.slug,
                onClick: function onClick(e) {
                  return _this.enableCategory(category);
                }
              }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
                primary: locationLabel[_this.props.currentLang]
              }));
            } else {
              return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
                key: "category-" + category.slug,
                button: true,
                selected: _this.state.activeCategory && _this.state.activeCategory.slug === category.slug,
                onClick: function onClick(e) {
                  return _this.enableCategory(category);
                }
              }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
                primary: category.name
              }));
            }
          }
        });
      } else {
        return /*#__PURE__*/_react["default"].createElement("div", null, noPredefinedLabel[_this.props.currentLang]);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderCategoryOptions", function () {
      if (_this.state.activeCategory) {
        if (_this.state.activeCategory.options && _this.state.activeCategory.options.length) {
          var options = _this.state.activeCategory.options;
          var labelProp = "name";
          var valueProp = "value";
          return options.map(function (option) {
            return /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
              key: option.id
            }, /*#__PURE__*/_react["default"].createElement(_ListItemText["default"], {
              primary: option[labelProp]
            }), !_this.state.activeCategory.is_secure ? /*#__PURE__*/_react["default"].createElement(_ListItemSecondaryAction["default"], null, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
              edge: "end",
              "aria-label": "delete",
              onClick: function onClick(e) {
                return _this.deleteOption(option);
              }
            }, /*#__PURE__*/_react["default"].createElement(_Delete["default"], null))) : "");
          });
        } else if (_this.state.activeCategory.is_secure) {
          return /*#__PURE__*/_react["default"].createElement("span", null, noOptionsLabel[_this.props.currentLang]);
        } else {
          return /*#__PURE__*/_react["default"].createElement("span", null, createNewOptionsLabel[_this.props.currentLang]);
        }
      } else {
        return /*#__PURE__*/_react["default"].createElement("span", null, viewOptionsLabel[_this.props.currentLang]);
      }
    });

    var active = null;

    if (props.selected) {
      for (var i = 0; i < props.predefined.length; i++) {
        if (props.predefined[i].is_public && props.predefined[i].id === _this.props.selected) {
          active = props.predefined[i];
          break;
        }
      }
    }

    _this.state = {
      open: false,
      activeCategory: active,
      addCategory: false,
      newCategoryName: "",
      showAddCategoryMsg: false,
      insertError: null
    };
    return _this;
  }

  var _proto = PredefinedValues.prototype;

  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-width-full ahfb-text-right"
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      onClick: this.handleClickOpen
    }, this.state.activeCategory && this.state.activeCategory.isPublic ? /*#__PURE__*/_react["default"].createElement(_Done["default"], null) : "", " ", addLabel[this.props.currentLang])), /*#__PURE__*/_react["default"].createElement(_Dialog["default"], {
      open: this.state.open,
      onClose: this.handleClose,
      PaperComponent: PaperComponent,
      "aria-labelledby": "draggable-dialog-title",
      maxWidth: "xl"
    }, /*#__PURE__*/_react["default"].createElement(_AppBar["default"], {
      className: "ahfb-position-relative"
    }, /*#__PURE__*/_react["default"].createElement(_Toolbar["default"], null, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
      variant: "h6"
    }, addLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      className: "ahfb-position-absolute ahfb-shift-right",
      color: "inherit",
      onClick: this.handleClose,
      "aria-label": "close"
    }, /*#__PURE__*/_react["default"].createElement(_Close["default"], null)))), /*#__PURE__*/_react["default"].createElement(_DialogContent["default"], null, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
      container: true,
      className: "ahfb-dialog-content-root"
    }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
      item: true,
      xs: 5,
      className: "ahfb-pr-1 ahfb-categories-list-container"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "ahfb-position-relative"
    }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
      variant: "h6",
      component: "h6",
      className: "ahfb-categories-add-heading"
    }, /*#__PURE__*/_react["default"].createElement("span", null, categoryLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_core.Tooltip, {
      title: "Add a new category"
    }, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
      onClick: this.handleAddCategoryOpen,
      className: "ahfb-categories-add-icon " + (this.props.currentLang === "ar" ? "ahfb-width-50" : "")
    }, /*#__PURE__*/_react["default"].createElement(_Add["default"], null))))), this.renderAddCategory(), /*#__PURE__*/_react["default"].createElement(_List["default"], {
      className: "ahfb-categories-list"
    }, this.renderCategories())), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
      item: true,
      xs: 7
    }, /*#__PURE__*/_react["default"].createElement(_List["default"], null, this.renderCategoryOptions(), this.renderAddOption()))), !!this.state.insertError ? /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], {
      error: true
    }, this.state.insertError[this.props.currentLang]) : ""), /*#__PURE__*/_react["default"].createElement(_DialogActions["default"], null, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      autoFocus: true,
      onClick: this.handleClose,
      variant: "outlined"
    }, cancelLabel[this.props.currentLang]), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      onClick: this.handleInsert,
      variant: "contained"
    }, insertLabel[this.props.currentLang]))), /*#__PURE__*/_react["default"].createElement(_Snackbar["default"], {
      anchorOrigin: {
        vertical: "bottom",
        horizontal: "left"
      },
      open: this.state.showAddCategoryMsg,
      autoHideDuration: 6000,
      onClose: this.handleAddCategoryMsgClose,
      message: newCategoryLabel[this.props.currentLang],
      action: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_IconButton["default"], {
        size: "small",
        "aria-label": "close",
        color: "inherit",
        onClick: this.handleAddCategoryMsgClose
      }, /*#__PURE__*/_react["default"].createElement(_Close["default"], {
        fontSize: "small"
      })))
    }));
  };

  return PredefinedValues;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    predefined: state.form.predefined,
    predefinedEndpoint: state.form.predefinedEndpoint,
    currentLang: state.form.currentLang
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    addCategory: function addCategory(data) {
      return dispatch((0, _predefinedActions.addCategory)(data));
    },
    updateCategoryOptions: function updateCategoryOptions(data, slug) {
      return dispatch((0, _predefinedActions.updateCategoryOptions)(data, slug));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(PredefinedValues);

exports["default"] = _default;
module.exports = exports.default;