"use strict";

exports.__esModule = true;
exports["default"] = RichTextEditor;

var _react = _interopRequireDefault(require("react"));

var _ckeditor4React = _interopRequireDefault(require("ckeditor4-react"));

var _FormHelperText = _interopRequireDefault(require("@material-ui/core/FormHelperText"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function RichTextEditor(props) {
  var config = {
    extraPlugins: "justify,font,colorbutton",
    toolbarGroups: [{
      name: 'document',
      groups: ['doctools']
    }, {
      name: 'clipboard',
      groups: ['clipboard', 'undo']
    }, {
      name: 'editing',
      groups: ['find', 'selection', 'spellchecker', 'editing']
    }, {
      name: 'forms',
      groups: ['forms']
    }, {
      name: 'basicstyles',
      groups: ['basicstyles', 'cleanup']
    }, {
      name: 'paragraph',
      groups: ['list', 'indent', 'blocks', 'align', 'bidi', 'paragraph']
    }, {
      name: 'links',
      groups: ['links']
    }, {
      name: 'insert',
      groups: ['insert']
    }, {
      name: 'styles',
      groups: ['styles']
    }, {
      name: 'colors',
      groups: ['colors']
    }, {
      name: 'tools',
      groups: ['tools']
    }, {
      name: 'others',
      groups: ['others']
    }, {
      name: 'about',
      groups: ['about']
    }],
    removeButtons: 'Save,NewPage,Preview,Print,Cut,Copy,Paste,PasteText,Undo,Redo,Replace,SelectAll,Scayt,Form,Checkbox,Radio,TextField,Textarea,Select,Button,ImageButton,HiddenField,Subscript,Superscript,CopyFormatting,RemoveFormat,CreateDiv,BidiLtr,BidiRtl,Language,Anchor,Image,Flash,Table,Smiley,PageBreak,ShowBlocks,About'
  };

  var onEditorChange = function onEditorChange(evt) {
    props.handleChange(evt.editor.getData());
  };

  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_ckeditor4React["default"], {
    data: props.data,
    onChange: onEditorChange,
    config: config
  }), props.error && props.error !== '' ? /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], {
    error: true
  }, props.error) : "");
}

module.exports = exports.default;