"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _ExpansionPanel = _interopRequireDefault(require("@material-ui/core/ExpansionPanel"));

var _ExpansionPanelSummary = _interopRequireDefault(require("@material-ui/core/ExpansionPanelSummary"));

var _ExpansionPanelDetails = _interopRequireDefault(require("@material-ui/core/ExpansionPanelDetails"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _ExpandMore = _interopRequireDefault(require("@material-ui/icons/ExpandMore"));

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _FieldWrapper = _interopRequireDefault(require("../../components/app/FieldWrapper"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function Section(props) {
  var name = props.name,
      uuid = props.uuid,
      collapseable = props.collapseable;

  var _useState = (0, _react.useState)(true),
      expand = _useState[0],
      setExpand = _useState[1];

  var renderFields = function renderFields() {
    var fields = Object.values(props.data);
    var sectionFields = fields.filter(function (field) {
      if (field.parentId === uuid) return true;
      return false;
    });
    if (!sectionFields.length) return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        textAlign: 'center'
      }
    }, /*#__PURE__*/_react["default"].createElement("small", null, " Drop fields here"));
    return _lodash["default"].map(sectionFields, function (field, index) {
      return /*#__PURE__*/_react["default"].createElement(_ExpansionPanelDetails["default"], {
        style: {
          padding: 0
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          width: '100%'
        }
      }, /*#__PURE__*/_react["default"].createElement("li", {
        key: 'li-' + field.uuid,
        className: "d-block container-fluid"
      }, /*#__PURE__*/_react["default"].createElement(_FieldWrapper["default"], {
        data: field,
        key: field.uuid
      }))));
    });
  };

  var handleChange = function handleChange() {
    if (collapseable) setExpand(!expand);
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      marginTop: 10
    }
  }, /*#__PURE__*/_react["default"].createElement(_ExpansionPanel["default"], {
    elevation: 0,
    onChange: handleChange,
    expanded: expand
  }, /*#__PURE__*/_react["default"].createElement(_ExpansionPanelSummary["default"], {
    expandIcon: collapseable ? /*#__PURE__*/_react["default"].createElement(_ExpandMore["default"], null) : '',
    "aria-controls": "panel1a-content",
    id: "panel1a-header",
    style: {
      padding: 0
    }
  }, /*#__PURE__*/_react["default"].createElement(_Typography["default"], null, name)), expand ? /*#__PURE__*/_react["default"].createElement("hr", null) : '', renderFields()));
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    data: state.form.data,
    order: state.form.order
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setOrder: function (_setOrder) {
      function setOrder(_x) {
        return _setOrder.apply(this, arguments);
      }

      setOrder.toString = function () {
        return _setOrder.toString();
      };

      return setOrder;
    }(function (data) {
      return dispatch(setOrder(data));
    })
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps)(Section);

exports["default"] = _default;
module.exports = exports.default;